import { defineStore } from 'pinia'
import APIinterface from 'src/api/APIinterface'

export const useTransactionStore = defineStore('transaction', {
  state: () => ({
    transaction_data: [],
    delivery_option: [],
    services_list: [],
    loading: false,
    enabled_tip : false
  }),
  actions: {
    TransactionInfo () {
      this.transaction_data = []
      this.delivery_option = []
      this.services_list = []
      const $params = {
        cart_uuid: APIinterface.getStorage('cart_uuid'),
        local_id: APIinterface.getStorage('local_id'),
        choosen_delivery: []
      }
      this.loading = true
      APIinterface.TransactionInfo($params)
        .then(data => {
          this.transaction_data = data.details
          this.delivery_option = data.details.delivery_option
          this.services_list = data.details.services_list
        })
        .catch(error => {
          console.debug(error)
        })
        .then(data => {
          this.loading = false
        })
    },
    getTipSettings(data){
      APIinterface.fetchDataPost('getTipSettings',data)
          .then(data => {
            this.enabled_tip = data.details.enabled_tip
          })
          .catch(error => {
            this.enabled_tip = false
          })
          .then(data => {

          })
    },
  },
})
