import { defineStore } from 'pinia'
import APIinterface from 'src/api/APIinterface'

export const usestoreAvailable = defineStore('storeavailable', {
  state: () => ({
    code: 2,
    messsage: '',
    loading: false,
    loading_status : true,
    merchant_open_status : false,
    merchant_status_msg : '',
    merchant_uuid : '',
    loading_settings : true,
    booking_enabled : false,
    settings_data : [],
    after_addtocart : false,
    enabled_language : false,
    default_lang : '',
    language_list : [],
    merchant_delivery : false,
    addons_use_checkbox : false
  }),

  actions: {
    storeAvailable (merchantUUID) {
      this.loading = true
      APIinterface.storeAvailable('')
        .then(data => {
          this.code = data.code
        })
        .catch(error => {
          this.code = 2
          this.messsage = error
        })
        .then(data => {
          this.loading = false
        })
    },
    checkStoreOpen () {
      this.loading_status = true;
      const $data = APIinterface.getStorage("choosen_delivery");
      APIinterface.fetchDataPost('checkStoreOpen',$data)
        .then(data => {
          this.merchant_open_status = true;
          this.merchant_status_msg = data.msg;
        })
        .catch(error => {
          this.merchant_open_status = false;
          this.merchant_status_msg  = error;
        })
        .then(data => {
          this.loading_status = false;
        })
    },
    getSettings(){
      this.loading_settings = true;
      let $cart_uuid = !APIinterface.empty(APIinterface.getStorage('cart_uuid'))?APIinterface.getStorage('cart_uuid'):'';
      APIinterface.fetchDataPost('getSettings',"cart_uuid="+ $cart_uuid)
      .then(data => {
        this.merchant_uuid = data.details.merchant_uuid;
        this.settings_data = data.details;
        this.booking_enabled = data.details.booking_enabled;
        this.enabled_language = data.details.enabled_language;
        this.language_list = data.details.language_list;
        this.merchant_delivery = data.details.merchant_delivery;
        this.addons_use_checkbox = data.details.addons_use_checkbox;
      })
      .catch(error => {
        this.merchant_uuid = '';
        this.enabled_language = false;
        this.booking_enabled = false;
        this.settings_data = [];
        this.language_list  = [];
        this.merchant_delivery = false;
        this.addons_use_checkbox = false;
      })
      .then(data => {
        this.loading_settings = false;
      })
    }
  }
})
